"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.doTest = void 0;
const insert_port_1 = require("@deep-foundation/payments-tinkoff-c2b-test/src/insert-port");
const insert_route_1 = require("@deep-foundation/payments-tinkoff-c2b-test/src/insert-route");
const insert_sum_1 = require("@deep-foundation/payments-tinkoff-c2b-test/src/insert-sum");
const insert_terminal_key_1 = require("@deep-foundation/payments-tinkoff-c2b-test/src/insert-terminal-key");
const insert_terminal_password_1 = require("@deep-foundation/payments-tinkoff-c2b-test/src/insert-terminal-password");
const insert_do_test_1 = require("@deep-foundation/payments-tinkoff-c2b-test/src/insert-do-test");
const assert_1 = __importDefault(require("assert"));
const delay_1 = __importDefault(require("delay"));
// export async function doTest(arg: {
//   deep: DeepClient;
//   containerLinkId?: number;
//   terminalKey: string;
//   terminalPassword: string;
//   sum: number;
//   port: string;
//   route: string;
//   lookingForHandlerResultAttemptsCount?: number,
//   lookingForHandlerResultDelayInMs?: number
// }) {
function doTest(arg) {
    return __awaiter(this, void 0, void 0, function* () {
        const { deep, port, route, sum, terminalKey, terminalPassword, containerLinkId = deep.linkId, lookingForHandlerResultAttemptsCount = 10, lookingForHandlerResultDelayInMs = 1000 } = arg;
        yield (0, insert_terminal_key_1.insertTerminalKey)({
            deep,
            containerLinkId,
            terminalKey,
        });
        yield (0, insert_terminal_password_1.insertTerminalPassword)({
            deep,
            containerLinkId,
            terminalPassword,
        });
        yield (0, insert_sum_1.insertSum)({
            deep,
            containerLinkId,
            sum,
        });
        yield (0, insert_port_1.insertPort)({
            deep,
            containerLinkId,
            port,
        });
        yield (0, insert_route_1.insertRoute)({
            deep,
            containerLinkId,
            route,
        });
        const { data: [{ id: doTestLinkId }], } = yield (0, insert_do_test_1.insertDoTest)({
            deep,
            containerLinkId,
        });
        const resolvedTypeLinkId = yield deep.id('@deep-foundation/core', 'Resolved');
        const rejectedTypeLinkId = yield deep.id('@deep-foundation/core', 'Rejected');
        for (let i = 0; i < lookingForHandlerResultAttemptsCount; i++) {
            const { data: promiseTreeLinksDownToDoTestLink } = yield deep.select({
                up: {
                    parent_id: { _eq: doTestLinkId },
                    tree_id: { _eq: yield deep.id('@deep-foundation/core', 'promiseTree') },
                },
            });
            const rejectedLinkId = promiseTreeLinksDownToDoTestLink.find((link) => link.type_id === rejectedTypeLinkId);
            assert_1.default.strictEqual(rejectedLinkId, undefined);
            const resolvedLinkId = promiseTreeLinksDownToDoTestLink.find((link) => link.type_id === resolvedTypeLinkId);
            yield (0, delay_1.default)(lookingForHandlerResultDelayInMs);
        }
        assert_1.default.notStrictEqual(resolvedTypeLinkId, undefined);
    });
}
exports.doTest = doTest;
